/* Message Functions for Posting a DM */

  var bufferedMessage = "";
  var messageCharCount = 0;

 
 

  function trackPreviewMessage()
  {
    buildPreviewMessage();

    // these substitution hijinks are to get around pissy MSIE issues
    // where the pre-format tag isn't being respected - with out this the
    // spaces get compacted and the newlines don't wrap.
    $("preview_text_ID").innerHTML = bufferedMessage.replace(/\n/g,'<br>').replace(/ /g,'&nbsp;');
  }


  function validateForm()
  {
    var debugMe = 0;

     // now clean up any bad characters before the submission actually happens
    var messageHeadline = cleanTextFromMSWord(document.getElementById("headline_ID").value);
    var messageShortbody = cleanTextFromMSWord(document.getElementById("shortbody_ID").value);
    var messageLongbody = cleanTextFromMSWord(document.getElementById("longbody_ID").value);
    var formattedShortbody = cleanTextFromMSWord(document.getElementById("formatted_message_ID").value);

    // put the cleaned up message back in place too
    document.getElementById("headline_ID").value = messageHeadline;
    document.getElementById("shortbody_ID").value = messageShortbody;
    document.getElementById("longbody_ID").value = messageLongbody;
    document.getElementById("formatted_message_ID").value = formattedShortbody;

    var orgOrDept_elt = document.getElementById("submitter_org_ID");
    if (orgOrDept_elt.value == "")
    {
      alert("You must provide an organization or department for which you are submitting this message");
      orgOrDept_elt.focus();
      return false;
    }

    var audience1 = document.getElementById("audience_student_ID").checked;
    var audience2 = document.getElementById("audience_faculty_ID").checked;
    var audience3 = document.getElementById("audience_staff_ID").checked;
    var audience4 = 0; //document.getElementById("audience_other_community_ID").checked;
    if (debugMe > 1)
    {
      alert("audience1 == "+audience1);
      alert("audience2 == "+audience2);
      alert("audience3 == "+audience3);
      alert("audience4 == "+audience4);
      alert("combo == "+(! ((audience1) || (audience2) || (audience3) || (audience4))));
    }
    if (! ((audience1) || (audience2) || (audience3) || (audience4)))
    {
      alert("You must choose at least one audience for your message");
      document.getElementById("audience_student_ID").focus();
      return false;
    }

    var headline_elt = document.getElementById("headline_ID");
    var headline = headline_elt.value;
    if (headline == "")
    {
      alert("You must provide a headline/title for your message");
      headline_elt.focus();
      return false;
    }

    var shortbody_elt = document.getElementById("shortbody_ID");
    var shortbody = shortbody_elt.value;
    if (shortbody == "")
    {
      alert("You must write a message");
      shortbody_elt.focus();
      return false;
    }

    // old active date stuff
    //alert("activedate is "+activeDate);
    //alert("activedate match is "+activeDate.match(/^\d\d\d\d\/\d\d\/\d\d$/));
    //  && (! (activeDate.match(/^\d\d\d\d\/\d\d\/\d\d$/))))

    var dateDefaultValue = '----/--/--';
    var daysInFutureLimit = 30;
    var activeDate_elt = document.getElementById("active_date_ID");
    var activeDate = activeDate_elt.value;
    if (activeDate == dateDefaultValue)
    {
      //alert("If you enter an active date it must be in the format YYYY/MM/DD");
      alert("You must choose a date for the message, and it must be no earlier than tomorrow and no later than "+daysInFutureLimit+" days from now.");
      activeDate_elt.focus();
      return false;
    }
    else
    {
      if (debugMe > 1)
      {
        alert("active date="+activeDate+" - OK");
      }
    }

    var one_day=1000*60*60*24;
    var today=new Date();
    var aDate = '';
    var sDate = '';
    //alert('year='+activeDate.substring(0,4));
    //alert('month='+ltrim(activeDate.substring(5,7),'0'));
    //alert('day='+ltrim(activeDate.substring(8),'0'));
    aDate = new Date(activeDate.substring(0,4),parseInt(ltrim(activeDate.substring(5,7),'0'))-1,ltrim(activeDate.substring(8),'0'));

    //alert("today is "+today.toString()+"   aDate is "+aDate.toString()+"   sDate is "+sDate.toString());
    //alert('aDate - today is '+(aDate.getTime()-today.getTime())/one_day);

    var diff = ((aDate.getTime()-today.getTime())/one_day);
    //alert('diff is' + diff);

    if (diff < 0)
    {
      alert("The message date must be at least 1 day further in the future");
      activeDate_elt.focus();
      return false;
    }
    if (diff > daysInFutureLimit)
    {
      alert("The message date must be no more than "+daysInFutureLimit+" days from now.");
      activeDate_elt.focus();
      return false;
    }

    return true;
  }
  
  
  
    function ltrim(argvalue,trimchar) 
  {
    if (trimchar.length != 1)
    {
	trimchar = ' ';
    }
    while (1) 
    {
      if (argvalue.substring(0, 1) != trimchar)
      {
        break;
      }
      argvalue = argvalue.substring(1, argvalue.length);
    }
    return argvalue;
  }
  
   function onLoadHandler()
  {}

  // this function takes text and replaces various special characters with acceptable equivalents
  function cleanTextFromMSWord(dirty_text)
  {
    var pattern = /\u201C/g; // left 'smart' double quote
    dirty_text = dirty_text.replace(pattern,'"');

    pattern = /\u201D/g; // right 'smart' double quote
    dirty_text = dirty_text.replace(pattern,'"');

    pattern = /\u2018/g; // left 'smart' single quote
    dirty_text = dirty_text.replace(pattern,"'");

    pattern = /\u2019/g; // right 'smart' single quote
    dirty_text = dirty_text.replace(pattern,"'");

    pattern = /\u2022/g; // bullet
    dirty_text = dirty_text.replace(pattern,'*');

    pattern = /\uF0FC/g; // another kind of bullet
    dirty_text = dirty_text.replace(pattern,'*');

    pattern = /\u2013/g; // n-dash
    dirty_text = dirty_text.replace(pattern,'-');

    pattern = /\u2014/g; // m-dash
    dirty_text = dirty_text.replace(pattern,'-');

    pattern = /\u2026/g; // ellipsis
    dirty_text = dirty_text.replace(pattern,'...');

    pattern = /\uFFFD/g; // e-circumflex
    dirty_text = dirty_text.replace(pattern,'e');

    return dirty_text;
  }
